/*Diese Version 
- kann durch die Initialisierug *zeichen=NULL 
  auf die Variable _erst verzichten;
- verbindet nicht die Werte, sondern die Adresse von _zeichen 
  mit den Variablen in Get() und Put(). Die drei Funktionen nutzen 
  denselben physikalischen Speicher, der auch ein Feld sein kann. 
  Deshalb erbrigt sich auch die Variable _write: 
  Get() und Put() entscheiden selbst, ob sie dann lesen oder 
  schreiben (printf(), getch())
- verwendet eine neue Funktion common_(), die selbst als Zeiger 
  auf Put() fungieren kann, weil sie Put() als Rckgabe-Wert hat.
*/

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#define ENDE   27
#define EWIG    1

int (*common_ (char **zeichen))(void);
int Get(void);  int Put(void);

int Get(void) 
{ static char *zeichen=NULL;  /*static unnoetig, aber schneller*/
  static int (*p2f)(void)=NULL; /*NULL statt _erst*/
  if (!p2f || !zeichen) p2f = common_ (&zeichen);/*Speicherg in common_()*/
  printf ("\nGib Zeichen: ");  
  *zeichen = _getch(); 

  (*p2f)(); // auch: p2f();
  (*common_ (&zeichen))();/*p2f ist schneller!*/
  return (0);
}

int (*common_ (char **zeichen))(void)
{ static char _zeichen=' '; /*Auch als Feld ausbaubar*/
  if (!*zeichen) { *zeichen = &_zeichen; } /*Initialisierg*/

  if (**zeichen == ENDE) { printf ("\nDanke!\n"); _getch(); exit (0); }
  return(Put); // auch: return(&Put); 
}

int Put(void)
{ char  *zeichen=NULL;
  if (!zeichen) common_ (&zeichen);  
  printf ("\nDas war ein: %c \n", *zeichen);
  return (0);
}

int main(void) 
{ while (EWIG) 
  { Get(); /* Zeichen eigeben u. weiterschauen */
  }
  return 0;
}
